DIRNAME := arch/i386
SUBDIRS := kernel

include $(BASEDIR)/header.mk

# Architecture-specific definitions
CROSS_COMPILE ?= 
ARCH_KCFLAGS = -m32
ARCH_KLDFLAGS = -melf_i386

all: aedrix-boot.img

HD_IMAGE_SIZE := $(shell echo $$((4*1024*1024)))
HD_NUM_BLOCKS := $(shell echo $$(($(HD_IMAGE_SIZE)/4096)))
KERNEL_ARGS := 
aedrix-boot.img: aedrix-kernel.elf
	@echo '  BUILD   aedrix-boot.img'
	$(V)dd if=/dev/zero of="$@" bs=4k count=$(HD_NUM_BLOCKS) 2>/dev/null
	$(V)mkfs.vfat "$@" 1>/dev/null
	$(V)syslinux "$@"
	$(V)mcopy -i "$@" /usr/lib/syslinux/bios/mboot.c32 ::mboot.c32
	$(V)mcopy -i "$@" /usr/lib/syslinux/bios/libcom32.c32 ::libcom32.c32
	$(V)mcopy -i "$@" aedrix-kernel.elf ::kernel.bin
	$(V)mcopy -i "$@" arch/i386/syslinux.cfg ::syslinux.cfg

OBJS_$(d) := $(d)/start.o

KOBJS += $(OBJS_$(d))

include $(BASEDIR)/footer.mk

ARCH_QEMU_CMD = qemu-system-i386 -m 1024
