/*
    Copyright (C) 2012, Aaron Lindsay <aaron@aclindsay.com>

    This file is part of Aedrix.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#include <init.h>
#include <drivers/serial.h>

struct dlist_node serial_dev_list;

int serial_register_device(struct serial_dev *sdev) {
	if (!sdev)
		return -1;

	insert_before(&serial_dev_list, &sdev->list);
	return 0;
}

struct serial_dev *serial_first_device() {
	if (list_empty(&serial_dev_list))
		return 0;

	return container(serial_dev_list.next, struct serial_dev, list);
}

/*
 * Initialize the serial sybsystem.
 * Note: this is called directly from the kernel initialization as opposed to
 * being an initcall because it has to be called before the serial drivers get
 * initialized in earlyinitcalls.
 */
void serial_init() {
	init_list(&serial_dev_list);
}
