/*
    Copyright (C) 2012, Aaron Lindsay <aaron@aclindsay.com>

    This file is part of Aedrix.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#ifndef BCM2835_MAILBOX_H
#define BCM2835_MAILBOX_H

#include <types.h>

/* BCM2835 Mailbox Channels */
#define MBOX_PM		0	//Power management interface
#define MBOX_FB		1	//Framebuffer
#define MBOX_VUART	2	//Virtual UART
#define MBOX_YCHIQ	3	//VCHIQ interface
#define MBOX_LEDS	4	//LEDs interface
#define MBOX_BUTTONS	5	//Buttons interface
#define MBOX_TOUCHSCRN	6	//Touch screen interface

uint32 mailbox_read(uint32 channel);
void mailbox_write(uint32 channel, uint32 data);

#endif /* BCM2835_MAILBOX_H */
